searchData={"items":[{"type":"module","title":"BeamBenchmarks","doc":"BEAM Benchmarks\n\nSee functions for supported benchmarks.","ref":"BeamBenchmarks.html"},{"type":"function","title":"BeamBenchmarks.device_info/0","doc":"Return information about the device","ref":"BeamBenchmarks.html#device_info/0"},{"type":"function","title":"BeamBenchmarks.estone/1","doc":"Run estone_SUITE and pretty print the results\n\nThis is a suite of benchmarks that measure performance of various Erlang\nprimitives.\n\nSee `estone_bench/1` for machine readable results.","ref":"BeamBenchmarks.html#estone/1"},{"type":"function","title":"BeamBenchmarks.estone_bench/1","doc":"Run estone_SUITE benchmarks\n\nThis is a suite of benchmarks that measure performance of various Erlang\nprimitives.","ref":"BeamBenchmarks.html#estone_bench/1"},{"type":"type","title":"BeamBenchmarks.estone_options/0","doc":"","ref":"BeamBenchmarks.html#t:estone_options/0"},{"type":"module","title":"BeamBenchmarks.Bencherl","doc":"Bencherl benchmarks\n\nSee https://github.com/softlab-ntua/bencherl","ref":"BeamBenchmarks.Bencherl.html"},{"type":"function","title":"BeamBenchmarks.Bencherl.bang/1","doc":"Run bencherl's bang test\n\nA benchmark for many-to-one message passing that spawns one receiver and\nmultiple senders that flood the receiver with messages.","ref":"BeamBenchmarks.Bencherl.html#bang/1"},{"type":"type","title":"BeamBenchmarks.Bencherl.bencherl_options/0","doc":"Options for running bencherl tests\n\n* `version` - run a `:short`, `:intermediate`, `:long` version. Default is `:short`.\n* `number_of_cores` - the number of cores to use. Default is the number of schedulers.","ref":"BeamBenchmarks.Bencherl.html#t:bencherl_options/0"},{"type":"type","title":"BeamBenchmarks.Bencherl.bencherl_version/0","doc":"","ref":"BeamBenchmarks.Bencherl.html#t:bencherl_version/0"},{"type":"function","title":"BeamBenchmarks.Bencherl.big/1","doc":"Run bencherl's big test\n\nA benchmark that implements a many-to-many message passing scenario.","ref":"BeamBenchmarks.Bencherl.html#big/1"},{"type":"function","title":"BeamBenchmarks.Bencherl.ehb/1","doc":"Run bencherl's ehb test\n\nThis is an implementation of *hackbench* in Erlang, a benchmark and stress\ntest for Linux schedulers.","ref":"BeamBenchmarks.Bencherl.html#ehb/1"},{"type":"function","title":"BeamBenchmarks.Bencherl.ets_random_ops/1","doc":"Run bencherl's ets_random_ops test\n\nThis benchmark creates an ETS table and spawns several readers and writers\nthat perform a certain number of reads (lookups) and writes (inserts),\nrespectively, to that table.","ref":"BeamBenchmarks.Bencherl.html#ets_random_ops/1"},{"type":"function","title":"BeamBenchmarks.Bencherl.ets_test/1","doc":"Run bencherl's ets_test test\n\nThis benchmark creates an ETS table and spawns several readers and writers\nthat perform a certain number of reads (lookups) and writes (inserts),\nrespectively, to that table.","ref":"BeamBenchmarks.Bencherl.html#ets_test/1"},{"type":"function","title":"BeamBenchmarks.Bencherl.genstress/1","doc":"Run bencherl's genstress test\n\nThis is a generic server benchmark that spawns an echo server and a number of\nclients.","ref":"BeamBenchmarks.Bencherl.html#genstress/1"},{"type":"function","title":"BeamBenchmarks.Bencherl.mbrot/1","doc":"Run bencherl's mbrot test\n\nThis benchmark extrapolates the coordinates of a 2-D complex plane that\ncorrespond to the pixels of a 2-D image of a specific resolution.","ref":"BeamBenchmarks.Bencherl.html#mbrot/1"},{"type":"function","title":"BeamBenchmarks.Bencherl.moves/1","doc":"Run bencherl's moves test\n\nParallel benchmark program that solves the moves problem. A description of\nthe moves problem can be found in the ETS implementation report that can be\nfound here:\n\nhttps://github.com/kjellwinblad/ets_impl_project","ref":"BeamBenchmarks.Bencherl.html#moves/1"},{"type":"function","title":"BeamBenchmarks.Bencherl.orbit_int/1","doc":"Run bencherl's orbit_int test\n\nThis benchmark operates on a distributed hash table, and follows a\nmaster/worker architecture.","ref":"BeamBenchmarks.Bencherl.html#orbit_int/1"},{"type":"function","title":"BeamBenchmarks.Bencherl.parallel/1","doc":"Run bencherl's parallel test\n\nA benchmark for parallel execution that spawns a number of processes, each of\nwhich creates a list of $N$ timestamps and, after it checks that each element\nof the list is strictly greater than its previous one (as promised by the\nimplementation of erlang:now/0), it sends the result to its parent.","ref":"BeamBenchmarks.Bencherl.html#parallel/1"},{"type":"function","title":"BeamBenchmarks.Bencherl.pcmark/1","doc":"Run bencherl's pcmark test\n\nThis benchmark is also about ETS operations. It creates five ETS tables,\nfills them with values, and then spawns a certain number of processes that\nread the contents of those tables and update them. As soon as one process\nfinishes, a new process is spawned, until a certain total number of processes\nhas been reached. The benchmark is parameterized by the number of initial\nprocesses and the total number of processes.","ref":"BeamBenchmarks.Bencherl.html#pcmark/1"},{"type":"function","title":"BeamBenchmarks.Bencherl.ran/1","doc":"Run bencherl's ran test\n\nAnother benchmark for parallel execution that spawns a certain number of\nprocesses, each of which generates a list of ten thousand random integers,\nsorts it and sends its first half to the parent process. The benchmark\nreceives the number of processes as a parameter.","ref":"BeamBenchmarks.Bencherl.html#ran/1"},{"type":"function","title":"BeamBenchmarks.Bencherl.run_all/1","doc":"Run all bencherl tests","ref":"BeamBenchmarks.Bencherl.html#run_all/1"},{"type":"function","title":"BeamBenchmarks.Bencherl.serialmsg/1","doc":"Run bencherl's serialmsg test\n\nA benchmark about message proxying through a dispatcher. The benchmark spawns\na certain number of receivers, one dispatcher, and a certain number of\ngenerators. The dispatcher forwards the messages that it receives from\ngenerators to the appropriate receiver. Each generator sends a number of\nmessages to a specific receiver.","ref":"BeamBenchmarks.Bencherl.html#serialmsg/1"},{"type":"function","title":"BeamBenchmarks.Bencherl.timer_wheel/1","doc":"Run bencherl's timer_wheel test\n\nA timer management benchmark that spawns a certain number of processes that\nexchange *ping* and *pong* messages.","ref":"BeamBenchmarks.Bencherl.html#timer_wheel/1"},{"type":"module","title":"BeamBenchmarks.BenchmarksGame","doc":"Benchmarks Game benchmarks\n\nSee https://madnight.github.io/benchmarksgame/","ref":"BeamBenchmarks.BenchmarksGame.html"},{"type":"function","title":"BeamBenchmarks.BenchmarksGame.binary_trees/1","doc":"Run Benchmark Game's Binary Trees benchmark\n\nAllocate and deallocate many many binary trees\n\nhttps://madnight.github.io/benchmarksgame/binarytrees-description.html#binarytrees\n\nOptions:\n* `:n` - the number of iterations to run. Default is 10.","ref":"BeamBenchmarks.BenchmarksGame.html#binary_trees/1"},{"type":"function","title":"BeamBenchmarks.BenchmarksGame.chameneos_redux/1","doc":"Run Benchmark Game's Chameneos Redux benchmark\n\nSymmetrical thread rendezvous requests\n\nhttps://madnight.github.io/benchmarksgame/chameneosredux-description.html#chameneosredux\n\nOptions:\n* `:n` - the number of iterations to run. Default is 600.","ref":"BeamBenchmarks.BenchmarksGame.html#chameneos_redux/1"},{"type":"function","title":"BeamBenchmarks.BenchmarksGame.fannkuch_redux/1","doc":"Run Benchmark Game's Fannkuch benchmark\n\nThe fannkuch benchmark is defined by programs in [Performing Lisp Analysis of the FANNKUCH Benchmark](http://citeseerx.ist.psu.edu/viewdoc/summary?doi=10.1.1.35.5124), Kenneth R. Anderson and Duane Rettig. FANNKUCH is an abbreviation for the German word Pfannkuchen, or pancakes, in analogy to flipping pancakes. The conjecture is that the maximum count is approximated by n*log(n) when n goes to infinity.\n\nhttps://madnight.github.io/benchmarksgame/fannkuchredux-description.html#fannkuchredux\n\nOptions:\n* `:n` - the number of iterations to run. Default is 1000.","ref":"BeamBenchmarks.BenchmarksGame.html#fannkuch_redux/1"},{"type":"function","title":"BeamBenchmarks.BenchmarksGame.fasta/1","doc":"Run Benchmark Game's Fasta benchmark\n\nGenerate and write random DNA sequences\n\nhttps://madnight.github.io/benchmarksgame/fasta-description.html#fasta\n\nOptions:\n* `:io` - the IO device to write the output to. Required.\n* `:n` - the number of iterations to run. Default is 1000.","ref":"BeamBenchmarks.BenchmarksGame.html#fasta/1"},{"type":"function","title":"BeamBenchmarks.BenchmarksGame.k_nucleotide/1","doc":"Run Benchmark Game's K-Nucleotide benchmark\n\nHashtable update and k-nucleotide strings\n\nhttps://madnight.github.io/benchmarksgame/knucleotide-description.html#knucleotide\n\nOptions:\n* `:n` - the number of iterations to run. Default is 10.","ref":"BeamBenchmarks.BenchmarksGame.html#k_nucleotide/1"},{"type":"function","title":"BeamBenchmarks.BenchmarksGame.mandelbrot/1","doc":"Run Benchmark Game's Mandelbrot benchmark\n\nGenerate Mandelbrot set portable bitmap file\n\nhttps://madnight.github.io/benchmarksgame/mandelbrot-description.html#mandelbrot\n\nOptions:\n* `:io` - the IO device to write the output to. Required.\n* `:n` - the width of the square Mandelbrot picture. Default is 200.","ref":"BeamBenchmarks.BenchmarksGame.html#mandelbrot/1"},{"type":"function","title":"BeamBenchmarks.BenchmarksGame.nbody/1","doc":"Run Benchmark Game's n-body test\n\nModel the orbits of Jovian planets, using the same simple symplectic-integrator.\n\nhttps://madnight.github.io/benchmarksgame/nbody-description.html#nbody\n\nOptions:\n* `:n` - the number of iterations to run. Default is 1000.","ref":"BeamBenchmarks.BenchmarksGame.html#nbody/1"},{"type":"function","title":"BeamBenchmarks.BenchmarksGame.pidigits/1","doc":"Run Benchmark Game's Pi Digits benchmark\n\nStreaming arbitrary-precision arithmetic\n\nhttps://madnight.github.io/benchmarksgame/pidigits-description.html#pidigits\n\nOptions:\n* `:n` - the number of digits to calculate. Default is 27.","ref":"BeamBenchmarks.BenchmarksGame.html#pidigits/1"},{"type":"function","title":"BeamBenchmarks.BenchmarksGame.regex_redux/1","doc":"Run Benchmark Game's Regex Redux benchmark\n\nMatch DNA 8-mers and substitute magic patterns\n\nhttps://madnight.github.io/benchmarksgame/regexredux-description.html#regexredux\n\nOptions:\n* `:n` - the number of iterations to run. Default is 10.","ref":"BeamBenchmarks.BenchmarksGame.html#regex_redux/1"},{"type":"function","title":"BeamBenchmarks.BenchmarksGame.reverse_complement/1","doc":"Run Benchmark Game's Reverse Complement benchmark\n\nRead DNA sequences - write their reverse-complement\n\nhttps://madnight.github.io/benchmarksgame/revcomp-description.html#revcomp\n\nOptions:\n* `:n` - the number of iterations to run. Default is 10.","ref":"BeamBenchmarks.BenchmarksGame.html#reverse_complement/1"},{"type":"function","title":"BeamBenchmarks.BenchmarksGame.spectral_norm/1","doc":"Run Benchmark Game's Spectral benchmark\n\nMathWorld: [\"Hundred-Dollar, Hundred-Digit Challenge Problems\"](http://mathworld.wolfram.com/Hundred-DollarHundred-DigitChallengeProblems.html), [Challenge #3](http://mathworld.wolfram.com/SpectralNorm.html).\n\nhttps://madnight.github.io/benchmarksgame/spectralnorm-description.html#spectralnorm\n\nOptions:\n* `:n` - the number of iterations to run. Default is 1000.","ref":"BeamBenchmarks.BenchmarksGame.html#spectral_norm/1"},{"type":"function","title":"BeamBenchmarks.BenchmarksGame.thread_ring/1","doc":"Run Benchmark Game's Thread Ring benchmark\n\nSwitch from thread to thread passing one token\n\nhttps://madnight.github.io/benchmarksgame/threadring-description.html#threadring\n\nOptions:\n* `:n` - the number of messages to pass around the ring. Default is 1000.","ref":"BeamBenchmarks.BenchmarksGame.html#thread_ring/1"},{"type":"module","title":"BeamBenchmarks.Info","doc":"Utilities for returning information about the device","ref":"BeamBenchmarks.Info.html"},{"type":"function","title":"BeamBenchmarks.Info.all_info/0","doc":"","ref":"BeamBenchmarks.Info.html#all_info/0"},{"type":"type","title":"BeamBenchmarks.Info.t/0","doc":"","ref":"BeamBenchmarks.Info.html#t:t/0"},{"type":"module","title":"BeamBenchmarks.Results","doc":"Common results struct for benchmarks","ref":"BeamBenchmarks.Results.html"},{"type":"type","title":"BeamBenchmarks.Results.t/0","doc":"Results of a benchmark run\n\n* `name` - the name of the benchmark\n* `options` - the options passed to the benchmark\n* `results` - the return value from the benchmark\n* `duration_us` - the duration of the benchmark in microseconds","ref":"BeamBenchmarks.Results.html#t:t/0"},{"type":"extras","title":"BeamBenchmarks","doc":"# BeamBenchmarks\n\n[![Hex version](https://img.shields.io/hexpm/v/beam_benchmarks.svg \"Hex version\")](https://hex.pm/packages/beam_benchmarks)\n[![API docs](https://img.shields.io/hexpm/v/beam_benchmarks.svg?label=hexdocs \"API docs\")](https://hexdocs.pm/beam_benchmarks/doc/BeamBenchmarks.html)\n[![CircleCI](https://dl.circleci.com/status-badge/img/gh/fhunleth/beam_benchmarks/tree/main.svg?style=svg)](https://dl.circleci.com/status-badge/redirect/gh/fhunleth/beam_benchmarks/tree/main)\n\nThis is a collection of Erlang benchmarks copied from other projects for ease of\nuse. This project makes these benchmarks a hex dependency and helper function\naway. Some documentation is copied here for convenience, but please see\nthe source projects for more complete information.\n\nBenchmarks include:\n\nName   | Source   | Description\n------ | -------- | -----------\n`bang` | [bencherl][bencherl] |\tA benchmark for many-to-one message passing that spawns one receiver and multiple senders that flood the receiver with messages.\n`big`  | [bencherl][bencherl] | A benchmark that implements a many-to-many message passing scenario.\n`binary_trees` | [benchmarksgame][benchmarksgame] | Allocate and deallocate many many binary trees\n`chameneos_redux` | [benchmarksgame][benchmarksgame] | Symmetrical thread rendezvous requests\n`ehb`  | [bencherl][bencherl] |\tThis is an implementation of *hackbench* in Erlang, a benchmark and stress test for Linux schedulers.\n`estone` | [estone_SUITE.erl][estone_SUITE.erl] | This is a suite of benchmarks that measure performance of various Erlang primitives.\n`ets_test` | [bencherl][bencherl] | This benchmark creates an ETS table and spawns several readers and writers that perform a certain number of reads (lookups) and writes (inserts), respectively, to that table.\n`fannkuch_redux` | [benchmarksgame][benchmarksgame] | Flipping pancakes\n`fasta` | [benchmarksgame][benchmarksgame] | Generate and write random DNA sequences\n`genstress` | [bencherl][bencherl] | This is a generic server benchmark that spawns an echo server and a number of clients.\n`k_nucleotide` | [benchmarksgame][benchmarksgame] | Hashtable update and k-nucleotide strings\n`mandelbrot` | [benchmarksgame][benchmarksgame] | Generate Mandelbrot set portable bitmap file\n`mbrot` | [bencherl][bencherl] | This benchmark extrapolates the coordinates of a 2-D complex plane that correspond to the pixels of a 2-D image of a specific resolution.\n`nbody` | [benchmarksgame][benchmarksgame] | Model the orbits of Jovian planets using a simple symplectic-integrator\n`orbit_int` | [bencherl][bencherl] | This benchmark operates on a distributed hash table, and follows a master/worker architecture.\n`parallel`  | [bencherl][bencherl] | A benchmark for parallel execution that spawns a number of processes, each of which creates a list of $N$ timestamps and, after it checks that each element of the list is strictly greater than its previous one (as promised by the implementation of erlang:now/0), it sends the result to its parent.\n`pcmark` | [bencherl][bencherl] | This benchmark is also about ETS operations. It creates five ETS tables, fills them with values, and then spawns a certain number of processes that read the contents of those tables and update them. As soon as one process finishes, a new process is spawned, until a certain total number of processes has been reached. The benchmark is parameterized by the number of initial processes and the total number of processes.\n`pidigits` | [benchmarksgame][benchmarksgame] | Streaming arbitrary-precision arithmetic\n`ran` | [bencherl][bencherl] | Another benchmark for parallel execution that spawns a certain number of processes, each of which generates a list of ten thousand random integers, sorts it and sends its first half to the parent process. The benchmark receives the number of processes as a parameter.\n`regex_redux` | [benchmarksgame][benchmarksgame] | Match DNA 8-mers and substitute magic patterns\n`reverse_complement` | [benchmarksgame][benchmarksgame] | Read DNA sequences - write their reverse-complement\n`serialmsg` | [bencherl][bencherl] | A benchmark about message proxying through a dispatcher. The benchmark spawns a certain number of receivers, one dispatcher, and a certain number of generators. The dispatcher forwards the messages that it receives from generators to the appropriate receiver. Each generator sends a number of messages to a specific receiver.\n`spectral_norm` | [benchmarksgame][benchmarksgame] | The \"Hundred-Dollar, Hundred-Digit Challenge Problem\"\n`thread_ring` | [benchmarksgame][benchmarksgame] | Switch from thread to thread passing one token\n`timer_wheel` | [bencherl][bencherl] | A timer management benchmark that spawns a certain number of processes that exchange *ping* and *pong* messages.\n\n[bencherl]: https://github.com/softlab-ntua/bencherl\n[benchmarksgame]: https://madnight.github.io/benchmarksgame/\n[estone_SUITE.erl]: https://github.com/erlang/otp/blob/maint-27/erts/emulator/test/estone_SUITE.erl","ref":"readme.html"},{"type":"extras","title":"Installation - BeamBenchmarks","doc":"Adding `beam_benchmarks` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n      {:beam_benchmarks, \"~> 0.1\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Sample run - BeamBenchmarks","doc":"Here's an example run of the EStone benchmark from the Erlang/OTP source code.\n\n```elixir\niex> BeamBenchmarks.estone\nEStone test completed\n**** CPU speed UNKNOWN MHz ****\n**** Total time 0.95421 seconds ****\n**** ESTONES = 696638 ****\n\n    Title                            Millis        Estone       %    Loops\n\n{'ESTONES',696638}\nlist manipulation                    55              27511        7     6400\nsmall messages                       215             14442        10    1515\nmedium messages                      220             27669        14    1527\nhuge messages                        25              19659        4     52\npattern matching                     8               102649       5     1046\ntraverse                             18              26960        4     2834\nPort i/o                             153             29175        12    4800\nWork with large dataset              13              21564        3     1193\nWork with large local dataset        13              22174        3     1174\nAlloc and dealloc                    4               35418        2     3710\nBif dispatch                         12              162170       8     5623\nBinary handling                      34              14654        4     581\nets datadictionary                   34              32825        6     342\nGeneric server (with timeout)        114             22092        9     7977\nSmall Integer arithmetics            9               32213        3     4157\nFloat arithmetics                    2               14790        1     5526\nFunction calls                       12              62344        5     882\nTimers                               13              9553         2     2312\nLinks                                2               18776        1     30\n{:comment, 'UNKNOWN MHz, 696638 ESTONES'}\n```\n\nAll other benchmarks have a similar API that runs the one test and returns the\nresult, timing, and other info in a `t:BeamBenchmarks.Results.t/0` struct. These\nrun pretty quickly with default settings, but become much more interesting load\ngenerates when passed bigger arguments.\n\nHere's Benchmarks Game's `pidigits`:\n\n```elixir\niex> BeamBenchmarks.BenchmarksGame.pidigits\n%BeamBenchmarks.Results{\n  name: :pidigits,\n  results: \"3141592653\\t:10\\n5897932384\\t:20\\n6264338  \\t:27\\n\",\n  options: [n: 27],\n  duration_us: 4462\n}\niex> BeamBenchmarks.BenchmarksGame.pidigits(n: 10000)\n%BeamBenchmarks.Results{\n  name: :pidigits,\n  results: \"3141592653\" <> ...,\n  options: [n: 10000],\n  duration_us: 2463606\n}\n```","ref":"readme.html#sample-run"},{"type":"extras","title":"Licensing - BeamBenchmarks","doc":"Please see the individual source files for their licenses.","ref":"readme.html#licensing"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v0.2.0 - Changelog","doc":"* New features\n  * Added benchmarks from [Benchmarks Game](https://madnight.github.io/benchmarksgame/)\n  * Added common results struct for non-Estone tests. This makes is much easier\n    to extract timing info programmatically especially since the return values\n    for many tests aren't that important after they've been checked for correctness.\n  * Moved tests around to modules since the `BeamBenchmarks` module became\n    really big.","ref":"changelog.html#v0-2-0"},{"type":"extras","title":"v0.1.0 - Changelog","doc":"Initial release. Benchmarks should all compile and run on Elixir 1.18 and\nErlang/OTP 27.","ref":"changelog.html#v0-1-0"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}